# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PageFormDefinitionVersionContent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'created_date': 'datetime',
        'created_by': 'str',
        'name': 'str',
        'description': 'str',
        'change_log': 'str',
        'form': 'FormDefinitionVersionForm',
        'styles': 'str'
    }

    attribute_map = {
        'id': 'id',
        'created_date': 'createdDate',
        'created_by': 'createdBy',
        'name': 'name',
        'description': 'description',
        'change_log': 'changeLog',
        'form': 'form',
        'styles': 'styles'
    }

    def __init__(self, id=None, created_date=None, created_by=None, name=None, description=None, change_log=None, form=None, styles=None):  # noqa: E501
        """PageFormDefinitionVersionContent - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._created_date = None
        self._created_by = None
        self._name = None
        self._description = None
        self._change_log = None
        self._form = None
        self._styles = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if created_date is not None:
            self.created_date = created_date
        if created_by is not None:
            self.created_by = created_by
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if change_log is not None:
            self.change_log = change_log
        if form is not None:
            self.form = form
        if styles is not None:
            self.styles = styles

    @property
    def id(self):
        """Gets the id of this PageFormDefinitionVersionContent.  # noqa: E501


        :return: The id of this PageFormDefinitionVersionContent.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PageFormDefinitionVersionContent.


        :param id: The id of this PageFormDefinitionVersionContent.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def created_date(self):
        """Gets the created_date of this PageFormDefinitionVersionContent.  # noqa: E501


        :return: The created_date of this PageFormDefinitionVersionContent.  # noqa: E501
        :rtype: datetime
        """
        return self._created_date

    @created_date.setter
    def created_date(self, created_date):
        """Sets the created_date of this PageFormDefinitionVersionContent.


        :param created_date: The created_date of this PageFormDefinitionVersionContent.  # noqa: E501
        :type: datetime
        """

        self._created_date = created_date

    @property
    def created_by(self):
        """Gets the created_by of this PageFormDefinitionVersionContent.  # noqa: E501


        :return: The created_by of this PageFormDefinitionVersionContent.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this PageFormDefinitionVersionContent.


        :param created_by: The created_by of this PageFormDefinitionVersionContent.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def name(self):
        """Gets the name of this PageFormDefinitionVersionContent.  # noqa: E501


        :return: The name of this PageFormDefinitionVersionContent.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PageFormDefinitionVersionContent.


        :param name: The name of this PageFormDefinitionVersionContent.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this PageFormDefinitionVersionContent.  # noqa: E501


        :return: The description of this PageFormDefinitionVersionContent.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PageFormDefinitionVersionContent.


        :param description: The description of this PageFormDefinitionVersionContent.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def change_log(self):
        """Gets the change_log of this PageFormDefinitionVersionContent.  # noqa: E501


        :return: The change_log of this PageFormDefinitionVersionContent.  # noqa: E501
        :rtype: str
        """
        return self._change_log

    @change_log.setter
    def change_log(self, change_log):
        """Sets the change_log of this PageFormDefinitionVersionContent.


        :param change_log: The change_log of this PageFormDefinitionVersionContent.  # noqa: E501
        :type: str
        """

        self._change_log = change_log

    @property
    def form(self):
        """Gets the form of this PageFormDefinitionVersionContent.  # noqa: E501


        :return: The form of this PageFormDefinitionVersionContent.  # noqa: E501
        :rtype: FormDefinitionVersionForm
        """
        return self._form

    @form.setter
    def form(self, form):
        """Sets the form of this PageFormDefinitionVersionContent.


        :param form: The form of this PageFormDefinitionVersionContent.  # noqa: E501
        :type: FormDefinitionVersionForm
        """

        self._form = form

    @property
    def styles(self):
        """Gets the styles of this PageFormDefinitionVersionContent.  # noqa: E501


        :return: The styles of this PageFormDefinitionVersionContent.  # noqa: E501
        :rtype: str
        """
        return self._styles

    @styles.setter
    def styles(self, styles):
        """Sets the styles of this PageFormDefinitionVersionContent.


        :param styles: The styles of this PageFormDefinitionVersionContent.  # noqa: E501
        :type: str
        """

        self._styles = styles

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PageFormDefinitionVersionContent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PageFormDefinitionVersionContent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
